﻿//////////////////////////////////////////////////////////////////////////
// YUV Player 만들기
// 작성자 : 맨날맑음(전호진)
// 작성일 : 2010.02.09
// Blog : http://crynut84.tistory.com
// Mail : crynut84@gmail.com
// 현재 YUV4:2:0포맷과 CIF 크기만 가능.
//////////////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace YUV_Player
{
    public partial class MainForm : Form
    {
        PictureInfomation _pictureInfo = new PictureInfomation();
        Picture _picture;
        /// <summary>
        /// 현재 재생 위치
        /// </summary>
        int _position;

        public int Position
        {
            get { return _position; }
            set { _position = value; }
        }
        /// <summary>
        /// 재생에 필요한 타이머
        /// </summary>
        Timer _timer = new Timer();

        public Timer timer
        {
            get { return _timer; }
            set { _timer = value; }
        }
        //현재 재생 중인가?
        bool _isPlay = false;

        public bool IsPlay
        {
            get { return _isPlay; }
            set { _isPlay = value; }
        }

        public Picture picture
        {
            get { return _picture; }
            set { _picture = value; }
        }
        public PictureInfomation PictureInfo
        {
            get { return _pictureInfo; }
            set { _pictureInfo = value; }
        }


        public MainForm()
        {
            InitializeComponent();
            //폼에 파일을 끌어다 놓을 수 있도록 설정
            this.AllowDrop = true;
                                  
            //타이머 셋팅
            timer = new Timer();
            timer.Interval = 30;
            timer.Tick += new EventHandler(timer_Tick);
            //드레그 드롭 관련 이벤트
            this.DragOver += new DragEventHandler(MainForm_DragOver);
            this.DragDrop += new DragEventHandler(MainForm_DragDrop);
            this.DragLeave += new EventHandler(MainForm_DragLeave);

            //메뉴 관련 이벤트
            this.HelpMenuItem.Click += new EventHandler(HelpMenuItem_Click);
            this.OpenMenuItem.Click += new EventHandler(OpenMenuItem_Click);
            this.ExitMenuItem.Click += new EventHandler(ExitMenuItem_Click);
            this.CloseMenuItem.Click += new EventHandler(CloseMenuItem_Click);

            this.KeyDown += new KeyEventHandler(MainForm_KeyDown);
        }

        /// <summary>
        /// 라벨을 위한 쓰레드 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void statusBW_DoWork(object sender, DoWorkEventArgs e)
        {
         
        }

        /// <summary>
        /// 타이머 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void timer_Tick(object sender, EventArgs e)
        {
            if (picture == null) return;
            if (Position== picture.Movie.Length - 1)
            {
                timer.Stop();                
                Position = 0;
                IsPlay = false;
                this.toolStripStatusLabel1.Text = string.Format("프레임 : {0} 재생 완료!", Position);
                return;
            }
            if (picture.Movie[++Position] == null)
            {                
                Position--;
            }
            this.toolStripStatusLabel1.Text = string.Format("프레임 : {0}", Position);
            pictureBox1.Image = picture.Movie[Position];
        }

        /// <summary>
        /// 키보드 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void MainForm_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                //재생
                case Keys.Space:
                    Play();
                    break;                
            }
        }

        private void Play()
        {
            if (IsPlay)
            {
                timer.Stop();                
            }
            else
            {
                timer.Start();
            }
            IsPlay = !IsPlay;
        }


        /// <summary>
        /// 닫기 버튼 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void CloseMenuItem_Click(object sender, EventArgs e)
        {
            CloseYUV();
        }

        private void CloseYUV()
        {
            if (picture!=null)
            {
                picture = null;
                this.pictureBox1.Image = null;
                this.toolStripStatusLabel1.Text = "준비";
                IsPlay = false;
            }
        }

        /// <summary>
        /// 종료 버튼 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void ExitMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// 열기 버튼 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void OpenMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();      
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                PictureInfo.FilePath = dlg.FileName;
                ReadYUVFormat();
            }
        }

        /// <summary>
        /// 드레그 관련 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void MainForm_DragLeave(object sender, EventArgs e)
        {
            // to do..
        }

        /// <summary>
        /// 드레그 관련 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void MainForm_DragDrop(object sender, DragEventArgs e)
        {
            string[] files = e.Data.GetData(DataFormats.FileDrop) as string[];

            if (files != null)
            {
                if (files.Length > 1)
                {
                    MessageBox.Show(this.Owner, "파일을 하나만 드레그 하세요.", "다중 파일열기는 지원되지 않습니다.", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    this.Focus();
                    return;
                }
                else
                {
                    string[] temp = files[0].Split('\\');                    
                    PictureInfo.FilePath = files[0];
                    ReadYUVFormat();                  
                }
            }
        }

        /// <summary>
        /// YUV파일을 읽어 온다.
        /// </summary>
        private void ReadYUVFormat()
        {
            toolStripProgressBar1.Visible = true;
            picture = new Picture(PictureInfo);
            //첫 프레임부터 읽어서 화면에 뿌린다.
            pictureBox1.Image = picture.MakeFrame(0);
            MakeAllFrame();
        }

        /// <summary>
        /// 모든 프레임을 읽어 온다.
        /// </summary>
        private void MakeAllFrame()
        {
            int totalFrameNum = picture.Buf.Length / (picture.PictureInfo.frameSize + picture.PictureInfo.frameSize / 2);
            
            for (int i = 1; i < totalFrameNum; i++)
            {
                if (picture == null) return;
                BackgroundWorker bw = new BackgroundWorker();
                bw.DoWork += new DoWorkEventHandler(bw_DoWork);
                bw.RunWorkerAsync(i);
            }
        }

        void bw_DoWork(object sender, DoWorkEventArgs e)
        {
         
            BackgroundWorker bw = sender as BackgroundWorker;
            bw.DoWork -= bw_DoWork;


            int totalFrameNum = picture.Buf.Length / (picture.PictureInfo.frameSize + picture.PictureInfo.frameSize / 2);
            int frameNum = (int)e.Argument;

            picture.MakeFrame(frameNum);
            int percent = frameNum / (totalFrameNum / 100);
            toolStripProgressBar1.Value = percent;
            this.toolStripStatusLabel1.Text = "파일을 읽어 오는 중..";
            if (percent > 98)
            {
                toolStripProgressBar1.Value = 100;
                this.toolStripStatusLabel1.Text = "파일 읽기 완료! Space를 누르면 재생 됩니다.";
                toolStripProgressBar1.Value = 0;
                toolStripProgressBar1.Visible = false;
            }
            if (picture == null)
            {
                this.toolStripStatusLabel1.Text = "준비";
                toolStripProgressBar1.Value = 0;
                toolStripProgressBar1.Visible = false;
                return;
            }
            ((BackgroundWorker)sender).Dispose();
        }
        /// <summary>
        /// 드레그 관련 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void MainForm_DragOver(object sender, DragEventArgs e)
        {
            //드레그하는 개체가 파일이면
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                //마우스 커서를 Copy모양으로 바꿔준다.
                e.Effect = DragDropEffects.Copy;                
            }
            else
            {
                //아닐경우 커서의 모양을 θ 요런 모양으로 바꾼다.
                e.Effect = DragDropEffects.None;
            }
        }

        /// <summary>
        /// 도움말 메뉴 이벤트 핸들러
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void HelpMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show(this.Owner,
                "YUV Player (ver 1.0)\n"
            + "지원 포맷 : YUV4:2:0 CIF\n"
            + "만든이 : 맨날맑음(전호진)\n"
            + "Blog : http://crynut84.tistory.com\n"
            + "Mail : crynut84@gmail.com\n"
            + "2010. 02. 09",
            "YUV Player 정보",
            MessageBoxButtons.OK,
            MessageBoxIcon.Information);            
        }
    }
}
