﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace YUV_Player
{
    #region enum ImageType
    public enum ImageType
    {
        None,
        GrayImage,
        _422,
        _420
    }
    #endregion

    #region class FrameSize
    public static class FrameSize
    {
        readonly static Size _QCIF = new Size(176, 144);
        readonly static Size _CIF = new Size(352, 288);
        readonly static Size _SIF = new Size(352, 240);

        public static Size QCIF
        {
            get { return _QCIF; }
        }

        public static Size CIF
        {
            get { return _CIF; }
        }

        public static Size SIF
        {
            get { return _SIF; }
        }
    }
    #endregion

    public class PictureInfomation
    {
        ImageType _type;
        Size _size;
        bool _yOnly;
        string _filePath;
        int _frameSize;



        #region 프로퍼티
        public int frameSize
        {
            get
            {
                return Size.Width * Size.Height;
            }

        }

        public bool Yonly
        {
            get { return _yOnly; }
            set { _yOnly = value; }
        }

        public ImageType Type
        {
            get { return _type; }
            set { _type = value; }
        }

        public Size Size
        {
            get { return _size; }
            set { _size = value; }
        }

        public string FilePath
        {
            get
            {
                if (_filePath.Length > 0)
                {
                    return _filePath;
                }
                else
                {
                    return null;
                }
            }
            set { _filePath = value; }
        }
        #endregion

        public PictureInfomation()
        {
            InitPictureInfomation(ImageType._420, FrameSize.CIF, false, "");
        }

        public PictureInfomation(ImageType _type, Size _size, bool _yOnly)
        {
            InitPictureInfomation(_type, _size, _yOnly, "");
        }

        public PictureInfomation(ImageType _type, Size _size, bool _yOnly, string _filePath)
        {
            InitPictureInfomation(_type, _size, _yOnly, _filePath);
        }

        void InitPictureInfomation(ImageType _type, Size _size, bool _yOnly, string _filePath)
        {
            Type = _type;
            Size = _size;
            Yonly = _yOnly;
            FilePath = _filePath;
            _frameSize = Size.Width * Size.Height;
        }
    }
}
